%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Dynamic Syntax
%
% parser
%
% Matthew Purver, 2002
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

:- use_module( library( lists ), [member/2] ).

% parse/3 - parse( +TreeList1, +WordList, ?TreeList2 )
% Adds words in WordList one by one, proceeding from the input forest TreeList1
% to the resulting output forest TreeList2
parse( Trees, [], Trees ).
parse( Trees1, [H | T], Trees3 ) :-
	parse_word( Trees1, H, Trees2 ),
	parse( Trees2, T, Trees3 ).

% parse_word( +TreeList1, +Word, -TreeList2 )
% Adds a single word, extending the input forest TreeList1 to the resulting
% possible output forest TreeList2
parse_word( _Trees1, Word, [] ) :-
	atom( Word ),
	\+ word( Word, _Action ),
	print( 'unknown word: ' ), print( Word ), newline.
parse_word( Trees1, Word, Trees2 ) :-
	atom( Word ),
	print( 'word: ' ), print( Word ), newline,
	findall( Tree2, (
			  member( Tree1, Trees1 ),
			  word( Word, Action ),
			  exec( Tree1, Action, Tree1b ),
			  adjust( Tree1b, Tree2 )
			), Trees2 ).
